// -*-C++-*-
/*!
 * @file  connectorSHMSVC_impl.h
 * @brief Service implementation header of connectorSHM.idl
 *
 */

#include "connectorSHMSkel.h"
#include <string>

#ifndef CONNECTORSHMSVC_IMPL_H
#define CONNECTORSHMSVC_IMPL_H
 
/*
 * Example class implementing IDL interface requestID
 */
class requestIDSVC_impl
 : public virtual POA_requestID,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~requestIDSVC_impl();

   //flagment
   short requestFlag;

	 // client use(provider)
   long myShmID, mySemID;

	 // SHM server using(consumer)
   short  req_control;
   std::string req_explain;
   long   req_byte;
   char req_explain_buf[100];

 public:
   // standard constructor
   requestIDSVC_impl();
   virtual ~requestIDSVC_impl();

   // attributes and operations
	
	// for provider (client)
   void request(CORBA::Short control, CORBA::Long byte, const char* explain);
   CORBA::Long getShmID();
   CORBA::Long getSemID();

	// for cosumer (Server)
   char* getExplain();
   //void getExplain(const char* buf);
   CORBA::Long getByte();
   CORBA::Short getControl();
   CORBA::Short getRequestFlag();
   void setIDs(CORBA::Long shmID, CORBA::Long semID);
   void setRequestFlag(CORBA::Short condition);

};



#endif // CONNECTORSHMSVC_IMPL_H


