// -*- C++ -*-
/*!
 * @file  SHMserver.cpp
 * @brief SharedMemoryServerComponent
 * $Date$
 *
 * $Id$
 */

#include "SHMserver.h"

// Module specification
// <rtc-template block="module_spec">
static const char* shmserver_spec[] =
  {
    "implementation_id", "SHMserver",
    "type_name",         "SHMserver",
    "description",       "SharedMemoryServerComponent",
    "version",           "3.0",
    "vendor",            "Takasi Kojima,klab",
    "category",          "database",
    "activity_type",     "",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

SHMserver::SHMserver(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_synchronizeInportIn("synchronizeInport", m_synchronizeInport),
    m_updateIn("update", m_update),
    m_synchronizeOutportOut("synchronizeOutport", m_synchronizeOutport),
    // </rtc-template>
		sync_in(this),sync_out(this),
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("synchronizeInport", m_synchronizeInportIn);
  registerInPort("update", m_updateIn);
  
  // Set OutPort buffer
  registerOutPort("synchronizeOutport", m_synchronizeOutportOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
	#ifndef NO_VECTOR
  m_provideIDs.resize(MAX_PORTNUMBER);
	#endif
	//m_provideIDs.clear();
	
  // Set CORBA Service Ports
	for(int i(0);i<DEFALT_PORT_NUM;i++)incPort();
  // </rtc-template>

}

SHMserver::~SHMserver()
{
}


RTC::ReturnCode_t SHMserver::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
	
  // </rtc-template>
  return RTC::RTC_OK;
}




RTC::ReturnCode_t SHMserver::onFinalize()
{
	sync_in.end();
	sync_out.end();
	shmManager.eraseAll();
	system("rm ./shmFiles -rf");
	deleteAllPort();
	return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t SHMserver::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t SHMserver::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}



RTC::ReturnCode_t SHMserver::onActivated(RTC::UniqueId ec_id)
{
	sync_in.start();
	sync_out.start();
	std::cout << "sychro thread ID --- In : " <<sync_in.getThreadID() << " Out : "  <<sync_out.getThreadID() << std::endl;
  return RTC::RTC_OK;
}



RTC::ReturnCode_t SHMserver::onDeactivated(RTC::UniqueId ec_id)
{
	//thread̏I҂
	sync_in.wait();
	sync_out.wait();
  return RTC::RTC_OK;
}



RTC::ReturnCode_t SHMserver::onExecute(RTC::UniqueId ec_id)
{
	long sharedmemoryID(-10),semaphoreID(-10);//lƂ̋ʗp
	unsigned long emptyPort(0);

	//solve request
	for(unsigned long i(0);i<m_provideIDPorts.size();i++)
	{
		sharedmemoryID = semaphoreID = -10; 
		if(m_provideIDs[i].getRequestFlag() == 1)// request == true
		{
			#ifdef DEBUG_PRINT
			//request parameter display
			std::cout << "-> Request : " << "Control[" <<  m_provideIDs[i].getControl()  << "] explain[" << m_provideIDs[i].getExplain() << "] size[" << m_provideIDs[i].getByte() << "byte]" << std::endl;
			#endif
			//make shared memory
			switch(m_provideIDs[i].getControl())
			{
				case 1: //L̒ǉ or f^b`
					shmManager.add(m_provideIDs[i].getByte(),m_provideIDs[i].getExplain());
					sharedmemoryID = shmManager.returnShmID(m_provideIDs[i].getByte(),m_provideIDs[i].getExplain());
					semaphoreID    = shmManager.returnSemID(m_provideIDs[i].getByte(),m_provideIDs[i].getExplain());
					break;
				case -1: //L̍폜 or f^b`
					shmManager.erase(m_provideIDs[i].getByte(),m_provideIDs[i].getExplain());
					semaphoreID    = -1;
					sharedmemoryID = -1;
					break;
				default:
					std::cout << "control must be 1 or -1 (attach or detach)" << std::endl;
					continue;
			}
			
			//set shared memory id
			m_provideIDs[i].setIDs(sharedmemoryID,semaphoreID);
			#ifdef DEBUG_PRINT
			std::cout << "<- Reply   :  sharedmemory id: " <<  sharedmemoryID  << " semaphore id: " << semaphoreID << std::endl;
			#endif

			//request clientɑ΂đ슮tO
			m_provideIDs[i].setRequestFlag(2);
			std::cout << "\x1b[34m-------------------------- managing list\x1b[39m"  << std::endl;
			shmManager.display();
			std::cout << std::endl;

		}
		// port has none active client or no connection //ANeBuȃNCAg邩Aڑ
	  if(m_provideIDs[i].getRequestFlag() == 0)emptyPort++;
	}
	
	// no empty port //̃|[gȂꍇ
	if(!emptyPort)incPort();

	//have any update from client. //XV͂ǂ
	//if(m_updateIn.isNew())synchronizeMemorySend();

	//have any input for sync. //p͂
	//if(m_synchronizeInportIn.isNew())synchronizeMemoryReceive();

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t SHMserver::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMserver::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMserver::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMserver::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMserver::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

// increase service port

void SHMserver::incPort()
{
	if(dynamicPortCounter > (long)MAX_PORTNUMBER)
	{
		std::cout << "Port number is over MAX_PORTNUMBER(" << MAX_PORTNUMBER << ")" << std::endl;
		return ;
	}
	std::string requestName("requestID");
	std::string providePortName("provideID");
	providePortName += otos(dynamicPortCounter);

	// value increase (why fault?)
#ifdef NO_VECTOR

#else
	requestIDSVC_impl tmpProvide;
	m_provideIDs.push_back(tmpProvide);
#endif

	// port increase
	m_provideIDPorts.push_back(new RTC::CorbaPort(providePortName.c_str()));
#ifdef NO_VECTOR
	m_provideIDPorts.back()->registerProvider(requestName.c_str() ,requestName.c_str() ,m_provideIDs[dynamicPortCounter]);
#else
	m_provideIDPorts.back()->registerProvider(requestName.c_str() ,requestName.c_str() ,m_provideIDs[dynamicPortCounter]);
#endif
	//registing port
	registerPort(*m_provideIDPorts.back());

	dynamicPortCounter++;

}

// decrease service port
void SHMserver::decPort(int number)
{
	std::string providePortName("provideID");
	providePortName += otos(number);

	//port̓o^폜
	deletePortByName(providePortName.c_str());

	//w肳ꂽ|[g폜
	std::vector<RTC::CorbaPort *>::iterator portItr;
	for(portItr=m_provideIDPorts.begin(); portItr!=m_provideIDPorts.end() ;++portItr){
		if(providePortName == (std::string) ((*portItr)->get_port_profile()->name) ){
			delete (*portItr);
			m_provideIDPorts.erase(portItr);
//			std::cout  << "delete : " << providePortName.c_str() << std::endl;
			break;
		}
	}
	//ł͎̂č폜Ȃ
}

// delete all service ports
void SHMserver::deleteAllPort()
{
	while(m_provideIDPorts.size())decPort(m_provideIDPorts.size()-1);
	std::cout << "Finish deleting all port" << std::endl;
#ifndef NO_VECTOR
	m_provideIDs.clear();
#endif
}

void SHMserver::synchronizeMemorySend(){
	int l_semid,l_shmid;//local semaphore ID, local sharedmemory ID

	// informed update -> shm,sem ID
	m_updateIn.read();
	l_shmid=shmManager.returnShmID(m_update.byte,m_update.explain);
	l_semid=shmManager.returnSemID(m_update.byte,m_update.explain);

	//correct IDs
	if(l_shmid>0 && l_semid>0)
	{
		#ifdef DEBUG_PRINT
		fprintf(stdout,"Sync. Send[%s %dbyte] shm id: %d   sem id: %d)\n"
			,(char*)m_update.explain,(int)m_update.byte,l_shmid,l_semid);
		#endif //PRINT
		shmptr = shmClient.returnPointer(l_shmid);
		if(shmptr != NULL){
			shmClient.lock(l_semid);
			m_synchronizeOutport.syn_explain  = m_update.explain;
			m_synchronizeOutport.syn_byte     = m_update.byte;
			m_synchronizeOutport.syn_data.length(m_update.byte);
			memcpy(&(m_synchronizeOutport.syn_data[0]),shmptr,m_update.byte);
			shmClient.unlock(l_semid);
			m_synchronizeOutportOut.write();
		}
	}
	else
	{
		//maybe not happen
		fprintf(stdout,"Error cannot get id\n");
	}
}

void SHMserver::synchronizeMemoryReceive(){
	int l_semid,l_shmid;//local semaphore ID, local sharedmemory ID
	m_synchronizeInportIn.read();
	l_shmid=shmManager.returnShmID(m_synchronizeInport.syn_byte,m_synchronizeInport.syn_explain);
	l_semid=shmManager.returnSemID(m_synchronizeInport.syn_byte,m_synchronizeInport.syn_explain);
	if(l_shmid>0 && l_semid>0)
	{
#ifdef DEBUG_PRINT
     fprintf(stdout,"Sync. Rcv[%s %dbyte] shm id: %d   sem id: %d\n"
                	,(char*)m_synchronizeInport.syn_explain,(int)m_synchronizeInport.syn_byte,l_shmid,l_semid);
#endif
		shmptr = shmClient.returnPointer(l_shmid);
		if(shmptr != NULL){
			shmClient.lock(l_semid);
			memcpy(shmptr,&(m_synchronizeInport.syn_data[0]),m_synchronizeInport.syn_byte);
			shmClient.unlock(l_semid);
			m_synchronizeOutportOut.write();
		}
	}
#ifdef DEBUG_PRINT
	else fprintf(stdout,"Sync. Rcv[%s %dbyte] No match data.\n",(char*)m_synchronizeInport.syn_explain,(int)m_synchronizeInport.
syn_byte);
#endif
}


extern "C"
{
 
  void SHMserverInit(RTC::Manager* manager)
  {
    RTC::Properties profile(shmserver_spec);
    manager->registerFactory(profile,
                             RTC::Create<SHMserver>,
                             RTC::Delete<SHMserver>);
  }
  
};


