// -*- C++ -*-
/*!
 * @file  VirtualH8.h
 * @brief VirtualH8
 * @date  $Date$
 *
 * $Id$
 */

#ifndef VIRTUALH8_H
#define VIRTUALH8_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">
#include "connectorSHMSVC_impl.h"

#include "sharedMemoryClient.h"
#include "ComStructure.h"

#define DEFAULT_IP_ADDRESS "192.168.1.127"
#define DEFAULT_PORT       "10001"
#define DIVIDE_NUMBER_DEFAULT 10

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

using namespace RTC;

class VirtualH8
  : public RTC::DataFlowComponentBase
{
 public:
  VirtualH8(RTC::Manager* manager);
  ~VirtualH8();

  // The initialize action (on CREATED->ALIVE transition)
  // formaer rtc_init_entry() 
 virtual RTC::ReturnCode_t onInitialize();

  // The finalize action (on ALIVE->END transition)
  // formaer rtc_exiting_entry()
  virtual RTC::ReturnCode_t onFinalize();

  // The startup action when ExecutionContext startup
  // former rtc_starting_entry()
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  // The shutdown action when ExecutionContext stop
  // former rtc_stopping_entry()
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  // The activated action (Active state entry action)
  // former rtc_active_entry()
   virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  // The deactivated action (Active state exit action)
  // former rtc_active_exit()
  virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  // The execution action that is invoked periodically
  // former rtc_active_do()
  virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  // The aborting action when main logic error occurred.
  // former rtc_aborting_entry()
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  // The error action in ERROR state
  // former rtc_error_do()
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  // The reset action that is invoked resetting
  // This is same but different the former rtc_init_entry()
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  // The state update action that is invoked after onExecute() action
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  // The action that is invoked when execution context's rate is changed
  // no corresponding operation exists in OpenRTm-aist-0.2.0
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // Configuration variable declaration
  // <rtc-template block="config_declare">
  
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  update_inform_connector m_informUpdateInPort;
  InPort<update_inform_connector> m_informUpdateInPortIn;
  
  // </rtc-template>

  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  update_inform_connector m_informUpdateOutPort;
  OutPort<update_inform_connector> m_informUpdateOutPortOut;
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  RTC::CorbaPort m_requestIDPort;
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  RTC::CorbaConsumer<requestID> m_requestID;
  
  // </rtc-template>

	//ʐMpϐQ
	std::string m_IPAddress;
	int m_portNumber;
	receive_data_struct rcv_data;
	send_data_struct    snd_data;

	//LϐQ
	long rcv_shm_id,rcv_sem_id;
	long snd_shm_id,snd_sem_id;

	receive_data_struct *rcvPtr;
	sharedMemoryClient<receive_data_struct> rcvClient;
	send_data_struct *sndPtr;
	sharedMemoryClient<send_data_struct>    sndClient;

 private:
	int processCounter;
	double angleAdder[6],speedAdder[6];
  int dummy;

};


extern "C"
{
  void VirtualH8Init(RTC::Manager* manager);
};

#endif // VIRTUALH8_H
