// -*-C++-*-
/*!
 * @file  connectorSHMSVC_impl.h
 * @brief Service implementation header of connectorSHM.idl
 *
 */

#include "connectorSHMSkel.h"


#ifndef CONNECTORSHMSVC_IMPL_H
#define CONNECTORSHMSVC_IMPL_H
 
/*
 * Example class implementing IDL interface requestID
 */
class requestIDSVC_impl
 : public virtual POA_requestID,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~requestIDSVC_impl();

 public:
   // standard constructor
   requestIDSVC_impl();
   virtual ~requestIDSVC_impl();

   // attributes and operations
   void request(CORBA::Short control, CORBA::Long byte, const char* explain);
   CORBA::Long getShmID();
   CORBA::Long getSemID();
   char* getExplain();
   CORBA::Long getByte();
   CORBA::Short getControl();
   void setIDs(CORBA::Long shmID, CORBA::Long semID);
   CORBA::Short getRequestFlag();
   void setRequestFlag(CORBA::Short condition);

};



#endif // CONNECTORSHMSVC_IMPL_H


